'''A Class for D&D 3.5 Mod'''

import es, dnds, popuplib, random, math
from dnds import dnds

def load():
    dnds.addClass('Knight', dnds.Grenades+dnds.Pistols+dnds.Rifles+['knife', 'm249'])

    knightinfo = popuplib.create('knightinformation')
    knightinfo.addline('-{ D&D CS:S - Knight }-')
    knightinfo.addline(' Weapons:  Grenades, Pistols, Rifles, and M249')
    knightinfo.addline(' Heavy Armor - 20% Damage Reduction')
    knightinfo.addline(' Toughness - Bonus Health')
    knightinfo.addline(' Minus 15% Speed')
    knightinfo.addline(' Your (target) is the person you last attacked while you did ')
    knightinfo.addline(' not have a target. You can only have one (target) at a time.')
    knightinfo.addline('-> 1. Powers 1-10')
    knightinfo.addline('-> 2. Powers 10-20')
    knightinfo.addline('-> 7. Play as a Knight')
    knightinfo.addline('-> 8. Back')
    knightinfo.addline('0. Exit')
    knightinfo.submenu(8, 'classinfo 1')
    knightinfo.submenu(1, 'knightpwrsinfo1')
    knightinfo.submenu(2, 'knightpwrsinfo2')
    knightinfo.menuselect = knightMenuSelect
    dnds.addClassInformation('Knight', 'knightinformation')

    pwrsinfo = popuplib.create('knightpwrsinfo1')
    pwrsinfo.addline('-{ Knight Powers - Lvls 1-10 }-')
    pwrsinfo.addline(' Lvl 1: Knight\'s Challenge - Gain extra damage against your (target)')
    pwrsinfo.addline(' Lvl 3: Shield Block - Chance to negate damage from an attack')
    pwrsinfo.addline(' Lvl 5: Bulwark of Defense - Nearby enemies are slowed')
    pwrsinfo.addline(' Lvl 7: Armor Mastery - Reduces your speed penalty')
    pwrsinfo.addline(' Lvl 9: Toughness - Bonus Health')
    pwrsinfo.addline(' Lvl 10: Die Hard - 10% DR')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'knightinformation')

    pwrsinfo = popuplib.create('knightpwrsinfo2')
    pwrsinfo.addline('-{ Knight Powers - Lvls 10-20 }-')
    pwrsinfo.addline(' Lvl 11: Shield Allies - Nearby allies gain DR')
    pwrsinfo.addline(' Lvl 13: Daunting Challenge - Shake your target')
    pwrsinfo.addline(' Lvl 15: Armor Mastery - Remove more of your speed penalty')
    pwrsinfo.addline(' Lvl 17: Weapon Focus - Gain bonus damage with rifles')
    pwrsinfo.addline(' Lvl 19: Vigilant Defender - Damage all enemies around you')
    pwrsinfo.addline(' Lvl 20: Loyal Beyond Death - On your death all allies heal')
    pwrsinfo.addline('-> 8. Back')
    pwrsinfo.addline('0. Exit')
    pwrsinfo.submenu(8, 'knightinformation')

def knightMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Knight'
        es.tell(userid, '#multi', 'You will be a Knight once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isClass(userid, 'Knight'):
        level = dnds.getLevel(userid, 'Knight')
        dnds.Health(userid, 15)
        Key['target'] = None
        Key['damage reduction'] += .2
        dnds.Speed(userid, -.15)
        if level >= 3:
            Key['dodge percent'] += 5
            Key['dodge max damage'] = 100
        if level >= 5:
            bulwarkLoop(userid)
        if level >= 7:
            dnds.Speed(userid, .05)
        if level >= 9:
            dnds.Health(userid, 15)
        if level >= 10:
            Key['damage reduction'] += .1
        if level >= 11:
            Key['allies'] = []
            shieldLoop(userid)
        if level >= 15:
            dnds.Speed(userid, .05)
        if level >= 19:
            vigilantLoop(userid)

def player_hurt(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    damage = int(float(ev['dmg_health']))
    if attacker:
        if dnds.isClass(attacker, 'Knight'):
            level = dnds.getLevel(attacker, 'Knight')
            Key = dnds.getPlayer(attacker)
            if not Key['target']:
                Key['target'] = userid
            if level >= 17 and ev['weapon'] in dnds.Rifles:
                dnds.Damage(userid, attacker, damage*.3)

def player_death(ev):
    userid = int(ev['userid'])
    for player in es.getUseridList():
        if dnds.isClass(player, 'Knight'):
            Key = dnds.getPlayer(player)
            if 'target' in Key:
                if Key['target'] == userid:
                    Key['target'] = None
    if dnds.isClass(userid, 'Knight'):
        if dnds.getLevel(userid, 'Knight') >= 20:
            es.tell(userid, '#multi', 'You are loyal beyond death... Your team has been healed with your passing.')
            for player in es.getUseridList():
                if es.getplayerteam(player) == es.getplayerteam(userid):
                    if not es.getplayerprop(player, 'CBasePlayer.pl.deadflag'):
                        dnds.Heal(player, 100)
                        es.tell(player, '#multi', '%s is loyal beyond death and has given you new vigor to fight in their death!'%es.getplayername(userid))

def bulwarkLoop(userid):
    x1,y1,z1 = es.getplayerlocation(userid)
    for player in es.getUseridList():
        if es.getplayerteam(player) != es.getplayerteam(userid):
            x2,y2,z2 = es.getplayerlocation(player)
            if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
                dnds.Speed(player, -.4, delay=1)
                #es.msg('bulk target %s'%es.getplayername(player))
    dnds.Delayed(userid, 1, bulwarkLoop, (userid))

def vigilantLoop(userid):
    x1,y1,z1 = es.getplayerlocation(userid)
    for player in es.getUseridList():
        if es.getplayerteam(player) != es.getplayerteam(userid):
            x2,y2,z2 = es.getplayerlocation(player)
            if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
                dnds.Damage(player, userid, 5)
                #es.msg('vig target %s'%es.getplayername(player))
    dnds.Delayed(userid, 1, vigilantLoop, (userid))

def shieldLoop(userid):
    Key = dnds.getPlayer(userid)
    for player in Key['allies']:
        if es.exists('userid', userid):
            dnds.getPlayer(player)['damage reduction'] -= .2
    Key['allies'] = []
    x1,y1,z1 = es.getplayerlocation(userid)
    for player in es.getUseridList():
        if player != userid:
            if es.getplayerteam(player) == es.getplayerteam(userid):
                x2,y2,z2 = es.getplayerlocation(player)
                if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 360:
                    dnds.getPlayer(player)['damage reduction'] += .2
                    Key['allies'].append(player)
                    #es.msg('shield target %s'%es.getplayername(player))
    dnds.Delayed(userid, 1, shieldLoop, (userid))
